<?php
/**
* @author Juan Padial (www.shikle.com)
* This plugin will automatically generate Meta Description tags for Agora forum component.
* version 1.0
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

// Import library dependencies
jimport('joomla.event.plugin');

class plgSystemMetagora extends JPlugin
{
  
	// Constructor
    function plgSystemMetagora( &$subject, $params )
    {
		parent::__construct( $subject, $params );
    }

    function onAfterDispatch()
    {
	global $mainframe;  
 
    	$option = JRequest::getCmd('option', '');
    	$document=& JFactory::getDocument();
    	$docType=$document->getType();
    	if (!$mainframe->isSite() || $docType != 'html') return;
    	if ($option !='com_agora') return;

        if ($option =='com_agora'){

	   $plugin =& JPluginHelper::getPlugin('system', 'Metagora');
	   $pluginParams = new JParameter( $plugin->params );
	   $agoratitle =$pluginParams->def('maintitle',$mainframe->getCfg('sitename')); 
           $agoradesc = $pluginParams->def('maindescription',$mainframe->getCfg('MetaDesc')); 
           $agorakeywords = $pluginParams->def('mainkeywords',$mainframe->getCfg('MetaKeys'));
           $length = $pluginParams->def('desclength','200');
	   $sep = str_replace('\\','',$pluginParams->def('separator','|')); //Sets and removes Joomla escape char bug.
	    
	    //get Agora variables from URL
            $task = JRequest::getCmd('task', '');
			// get integer to not escape $id in queries
            $id = JRequest::getInt('id', 0);

            //get database config
	    $database =& JFactory::getDBO();
       
            //Title and desc for agora board main page.
            //Skip from no forum or topic because for now only use for main page, categories, forums and topics.
            if($task=='' && !$id || ($task!='forum' && $task!='topic')){
                $pageTitle =$agoratitle; 
                $metadesc = $agoradesc; 
                $keywords = $agorakeywords;
            }
            
            //Category
            if($task=='' && $id){
               //get Category's name
               $query = "SELECT cat_name FROM #__agora_categories WHERE id ='$id' AND enable='1'";
               $database->SetQuery ($query);
               $cattitle = $database->loadResult();
               $pageTitle = $cattitle.' ' .$sep.' '.$agoratitle;
            
               //get categories descritpions from plugin params
               $categories = $pluginParams->def('categories','');

	            if($categories!='')
	            {
	             $categories = explode("\n",$categories);
	                  foreach($categories as $category) 
	                      {
		               // get the user-entered categories
		               list($catid,$catdesc) = explode("|",$category);
		               
                                 if($catid==$id)
                                 $metadesc=$catdesc;
                              }
                     }
                     else {
                      $metadesc=$agoradesc;
                     }
                 //get categories keywords
                 $categorieskw = $pluginParams->def('categorieskw','');
                 if($categorieskw !='')
	            {
	             $categorieskw = explode("\n",$categorieskw);
	                  foreach($categorieskw as $category) 
	                      {
		               // get the user-entered categories
		               list($catid,$catkey) = explode("|",$category);
		               
                                 if($catid==$id)
                                 $keywords=$catkey;
                              }
                     }
                     else {
                      $keywords=$agorakeywords;
                     }
              }  
            
            //Forum
            if($task=='forum'){
               //get forum name
               $query = "SELECT forum_name, forum_mdesc, forum_key FROM #__agora_forums WHERE id ='$id'";
               $database->SetQuery ($query);
               list($forumtitle,$forumdesc,$forumkey) = $database->loadRow();
               $pageTitle = $forumtitle.' '.$sep.' '.$agoratitle; 
			   
                if ($forumdesc!=''){
                  $metadesc = $forumdesc; 
                }
                else {
                  //if there is no frorum description set Agora board description as metadesc
                  $metadesc = $agoradesc;
                }
                if ($forumkey!=''){
                  $keywords = $forumkey; 
                }
                else {
                  //if there is no frorum keys set Agora board keys
                  $keywords=$agorakeywords;
                }
            }
            
            //Topic
            if($task=='topic'){
               //get topic subject
               $query = "SELECT subject,descrip_t FROM #__agora_topics WHERE id ='$id'";
               $database->SetQuery ($query);
               list($topictitle,$topicdesc) = $database->loadRow();
               $pageTitle = $topictitle.' '.$sep.' '.$agoratitle; 
               //get topic descritpion
                 if ($topicdesc!=''){
                    $metadesc = $topicdesc; 
                 }
                 else {
                    //if there is no topic description, get first post to set as metadesc
                    $query = "SELECT message FROM #__agora_posts WHERE topic_id ='$id' ORDER BY id ASC LIMIT 1";
                    $database->SetQuery ($query);
                    $topicdesc = $database->loadResult();
                    $metadesc = $topicdesc;
                }
                //TODO: get topic keywords.
                $text = $topictitle;
                $text .=$topicdesc;
                $query = "SELECT message FROM #__agora_posts WHERE topic_id ='$id' ORDER BY id ASC LIMIT 1";
                $text .= $database->loadRow();
                $listexclude = $pluginParams->def('listexclude','');
                $listgoldwords = $pluginParams->def('goldwords','');
                $mindensity = $pluginParams->def('mindensity','2');
                $minlength = $pluginParams->def('minlength','5');
                $maxwords = $pluginParams->def('maxwords','20');
                $keywords = keys($text,$listexclude,$listgoldwords,$mindensity,$minlength,$maxwords);
              }
	        // Set Metatags
	        $document->setTitle ($pageTitle);
	       	// Clean things up and prepare Meta Description tag.
		$metadesc = $this->cutText($metadesc);
		$metadesc = $metadesc . ' ';
		$metadesc = substr($metadesc,0,$length);
		$metadesc = substr($metadesc,0,strrpos($metadesc,' '));
                $document->setDescription ($metadesc);
                $document->setMetaData('keywords', $keywords);

	    }
	 }
	   
    function cutText($text) {
                $text=clean($text);
		// general sentence tidyup
		for ($cnt = 1; $cnt < strlen($text)-1; $cnt++) {
			// add a space after any full stops or comma's for readability
			// added as strip_tags was often leaving no spaces
			if (($text{$cnt} == '.') || ($text{$cnt} == ',')) {
				if ($text{$cnt+1} != ' ') {
					$text = substr_replace($text, ' ', $cnt + 1, 0);
				}
			}
		}
			
		return $text;
	}
   	
}
function keys($text,$listexclude,$listgoldwords,$mindensity,$minlength,$maxwords) {
     $text=clean($text);
    // str_word_count 0 - cuenta la cantidad de palabras de la cadena
    $words_count=str_word_count($text);
    
    // str_word_count 1- formar un array con las palabras
    $array_words=array($text);

    // strlen &#8212; Obtiene la longitud de la cadena
    $v=strlen($text); 

    $frequency = array_count_values( str_word_count( $text, 1) );
    arsort ($frequency);
    $words = array();
    $countwords=0;
    foreach( $frequency as $F => $value ) {

    // Creo que es la formula para la densidad de palabras...&#191; :) ?
    $density = round( ($value * 100) / ($words_count) );

    // trim &#8212; Elimina espacios en blanco (u otros caracteres) del principio y final de una cadena
    $frequent_word=trim($F);
   $excludewords = @explode ( ",",$listexclude);
   if ($frequent_word!=in_array($frequent_word,$excludewords) && !in_array($frequent_word,$words)) {
   
      $includewords = @explode(",",$listgoldwords);
    //  Excluir palabras poco frecuentes, inferiores a un minimo e incluir las que esten en la lista gold
    if($value >=$mindensity || in_array($frequent_word,$includewords)){

    // Obtener la longitud de la cadena de frecuencia
    $long=strlen($F);

    //  Excluir palabras con longitud de frecuencia inferior al minimo e incluir las que esten en la lista gold
    if($long >= $minlength || in_array($frequent_word,$includewords)){
     $words[]=$frequent_word;
     $countwords++;
     if ($countwords>$maxwords)break;
     }
    }
   }
 }
 $keywordslist = implode(',',$words);
 return $keywordslist;
}
function clean($text) {
    		$text = preg_replace( "'<script[^>]*>.*?</script>'si", '', $text );
		$text = preg_replace( '/<a\s+.*?href="([^"]+)"[^>]*>([^<]+)<\/a>/is', '\2 (\1)', $text );
		$text = preg_replace( '/<!--.+?-->/', '', $text );
		$text = preg_replace( '/{.+?}/', '', $text );
		$text = preg_replace( '/&nbsp;/', ' ', $text );
		$text = preg_replace( '/&amp;/', ' ', $text );
		$text = preg_replace( '/&quot;/', ' ', $text );
		$text = strip_tags( $text );
		$text = htmlspecialchars( $text );
             $text = str_replace(array("\r\n", "\r", "\n", "\t"), " ", $text);
        		while (strchr($text,"  ")) {
			$text = str_replace("  ", " ",$text);
		}
	return $text;
 }