<?php
/**
 * This file is part of the Agora distribution. 
 * Detailed copyright and licensing information can be found
 * in the gpl-3.0.txt file which should be included in the distribution.
 * 
 * @version		$Id: 3.0.14 Olympus 2010-09-28 rammstein4o $
 * @copyright  2007 - 2010 jVitals
 * @license   GPLv3 Open Source
 * @link       http://jvitals.com
 * @since      File available since initial release
 */	
 
class TaskController extends AgoraAdminController
{
	function loadModel()
	{
		$this->model = & Model::getInstance('RanksModel');
	}

	function _default()
	{
		$this->setPagination($this->model->loadAllCount());

		$this->model->setOrder('ORDER BY min_posts ASC');
		$ranks = $this->model->loadAll('',$this->pagination->per_page,$this->pagination->page);

		foreach ($ranks as $key=>$rank) {
			if ($rank['image'])
				$ranks[$key]['image'] = Agora::getSite().'img/ranks/'.$rank['image'];
		}

		$this->view->assign('ranks',$ranks);
		$this->view->template='configuration/ranks';
	}

	function add()
	{
		$rank = array('id'=>0,'min_posts'=>'','rank'=>'', 'user_type'=>'');
		$images = $this->model->loadImages();

		$this->view->assign('images',$images);
		$this->view->assign('rank',$rank);
		$this->view->assign('type','clean');
		$this->view->template='configuration/edit_rank';
	}

	function edit()
	{
		$cid = Agora::getPostVar('cid');
		if (is_array($cid)) {
			$id = array_shift($cid);
		} else {
			$id = Agora::getVar('id');
		}
		$rank = $this->model->load($id);
		$images = $this->model->loadImages();

		$this->view->assign('rank',$rank);
		$this->view->assign('images',$images);
		$this->view->template='configuration/edit_rank';
	}

	function save()
	{
		$rank = Agora::getPostVar('form',array());
		$id = Agora::getPostVar('id',0);

		if (trim($rank['min_posts']) == '' && !trim($rank['user_type'])) {
			Agora::showError(Agora::lang('Rank cannot be empty'));
			$this->redirect('task=configuration');
		}

		if (!$id) {
			$rank['min_posts'] = intval($rank['min_posts']);
			$exists = $this->model->load($rank['min_posts'],'min_posts');
			$exists_utype = $this->model->load($rank['user_type'],'user_type');
			
			if ( ($exists && !$rank['user_type']) || ($rank['user_type'] && $exists_utype) ) {
				Agora::showError(Agora::lang('Rank with this post numbers already exists'));
				$this->redirect('task=configuration');
			}
			$this->model->add($rank);
		} else {
			$this->model->edit($id,$rank);
		}

		Agora::showMessage(Agora::lang('Rank saved'));
		$this->redirect('task=configuration');
	}

	function cancel()
	{
		$this->redirect('task=configuration');
	}

	function remove()
	{
		$ids = Agora::getPostVar('cid',array());
		if (!is_array($ids)) {
			Agora::showError('Bad request');
			$this->redirect();
		}

		foreach($ids as $id) {
			$this->model->delete($id);
		}

		$this->redirect();
	}
}

?>