<?php

/**
* Joomla Community Builder User Plugin: plug_cbagora_plus
* @version $Id$
* @package plug_agoraplus
* @subpackage cb.agora.php
* @author Iskar Enev
* @copyright (C) Iskar Enev and Hazzaa, www.jVitals.com
* @license Limited  http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/


if ( !( defined( '_VALID_CB' ) || defined( '_JEXEC' ) || defined( '_VALID_MOS' ) ) ) {
    die( 'Direct Access to this location is not allowed.' );
}

require_once('agora.functions.php');

class getAgoraPreviewTab extends cbTabHandler {
/**
     * Construnctor
     */
    function getAgoraPreviewTab()
    {
        $this->cbTabHandler();
    }

    /**
    * Generates the HTML to display the user profile preview tab
    * @param object tab reflecting the tab database entry
    * @param object mosUser reflecting the user being displayed
    * @param int 1 for front-end, 2 for back-end
    * @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
    */
    function getDisplayTab($tab,$user,$ui)
    {
        global $_CB_framework;
        $return = null;

        $lang = JFactory::getLanguage();
        $lang->load('plg_cbagora_plus');

        //$params = $this->params; // get parameters (plugin and related tab)

        $agoraUser = cbAgoraGetUser($user->id);

        $dateFormat = cbAgoraDateFormat();
        $timeFormat = cbAgoraTimeFormat();
        $gmaps = cbAgoraGMaps();
        $lng = empty($agoraUser['longitude']) ? $gmaps['def_lng'] : $agoraUser['longitude'];
        $lat = empty($agoraUser['latitude']) ? $gmaps['def_lat'] : $agoraUser['latitude'];

        switch($agoraUser['gender']) {
            case 1:
                $gender = JText::_('CB_AGORA_GENDER_MALE');
                break;
            case 2:
                $gender = JText::_('CB_AGORA_GENDER_FEMALE');
                break;
            default:
                $gender = JText::_('CB_AGORA_GENDER_HIDDEN');
        }
		
		$opt_usermap = cbAgoraGetConf('o_usermap');
		$opt_usermap_key = cbAgoraGetConf('o_um_key');
		
        //section personal
        $return .= "<p>" . JText::_('CB_AGORA_USERNAME') . " :\t" . $agoraUser['username'] . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_TITLE') . ":\t" . $agoraUser['title'] . "</p>\n";
		
		if ($opt_usermap && $opt_usermap_key) {
		
			$return .= "<p>" . JText::_('CB_AGORA_LOCATION') .":\t" . $agoraUser['location'] . "</p>\n";

			$return .= "<script type=\"text/javascript\" src=\"http://maps.google.com/maps?file=api&amp;v=1&amp;key=".$gmaps['key']."\"></script>\n";
			$return .= "<script type=\"text/javascript\" src=\""
			  . $_CB_framework->getCfg('live_site') . "/components/com_comprofiler/plugin/user/plug_agoraplus/agora.js\"></script>\n";
			$return .= "<div id=\"map\" style=\"width: 500px; height: 400px; ;\"></div>\n";
			$return .= "<script type=\"text/javascript\">\n
						//<![CDATA[
						window.onload=";
			$return .= "gMapProfilePreview($lng, $lat, " . $gmaps['def_zoom'].");\n
						//]]>
						</script>\n";
		}
		
        $return .= "<p>" . JText::_('CB_AGORA_WEBSITE') . ":\t<a href=\"" . $agoraUser['url'] .  "\">" . $agoraUser['url'] . "</a></p>";
        $return .= "<p>" . JText::_('CB_AGORA_EMAIL') . ":\t<a href=\"mailto:" . $agoraUser['email'] .  "\">" . $agoraUser['email'] . "</a></p>";
        $return .= "<p>" . JText::_('CB_AGORA_GENDER') .":\t" . $gender ."</p>";

        $dateFormatTmp = $dateFormat;
        if ($agoraUser['hide_age']==1)
            $dateFormat = trim(eregi_replace('[ \./-]?y+[ \./-]?', '', $dateFormat));

        $return .= "<p>" . JText::_('CB_AGORA_BIRTHDAY') . ":\t". cbAgoraMonthFormat(date($dateFormat, $agoraUser['birthday']), $dateFormat) ."</p>";
        $return .= "<p>" . JText::_('CB_AGORA_INTERESTS') . ":\t" . $agoraUser['interests'] . "</p>";
        $return .= "<p>" . JText::_('CB_AGORA_ABOUTME') . ":\t" . $agoraUser['aboutme'] . "</p>";

        //section messaging
        $return .= cbAgoraMessagingSection($agoraUser);

        //section personality
        $return .= "<p>" . JText::_('CB_AGORA_SIGNATURE') . ":\t" . stripslashes(nl2br($agoraUser['signature'])) . "</p>\n";

        //user activity
        $return .= "<p>" . JText::_('CB_AGORA_POSTS') . ":\t" . $agoraUser['num_posts'] . "</p>";
        $return .= "<p>" . JText::_('CB_AGORA_LASTPOST') . ":\t" . date($dateFormatTmp. " " . $timeFormat, $agoraUser['last_post']) . "</p>";
        $return .= "<p>" . JText::_('CB_AGORA_REGISTERED') . ":\t" . date($dateFormatTmp. " " . $timeFormat, $agoraUser['registered']) . "</p>";

        return $return;
    } // end or getDisplayTab function
};

class getAgoraMessagingTab extends cbTabHandler{
/**
     * Construnctor
     */
    function getAgoraMessagingTab()
    {
        $this->cbTabHandler();
    }

    /**
    * Generates the HTML to display the user profile messaging tab
    * @param object tab reflecting the tab database entry
    * @param object mosUser reflecting the user being displayed
    * @param int 1 for front-end, 2 for back-end
    * @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
    */
    function getDisplayTab($tab,$user,$ui)
    {
        $lang = JFactory::getLanguage();
        $lang->load('plg_cbagora_plus');

        $return = null;
        $agoraUser = cbAgoraGetUser($user->id);
        $return .= cbAgoraMessagingSection($agoraUser);
        return $return;
    }

/**
    * Generates the HTML to display the user edit tab
    * @param object tab reflecting the tab database entry
    * @param object mosUser reflecting the user being displayed
    * @param int 1 for front-end, 2 for back-end
    * @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
    */
    function getEditTab($tab, $user, $ui)
    {
        $return = null;
        $lang = JFactory::getLanguage();
        $lang->load('plg_cbagora_plus');
        $agoraUser = cbAgoraGetUser($user->id);

        $return .= "<p><input type=\"text\" name=\"jabber\" value=\""
            . $agoraUser['jabber'] . "\" size=\"40\" maxlength=\"75\" />Jabber</p>\n";
        $return .= "<p><input type=\"text\" name=\"icq\" value=\""
            . $agoraUser['icq'] . "\" size=\"12\" maxlength=\"12\" />ICQ</p>\n";
        $return .= "<p><input type=\"text\" name=\"msn\" value=\""
            . $agoraUser['msn'] . "\" size=\"40\" maxlength=\"50\" />MSN</p>\n";
        $return .= "<p><input type=\"text\" name=\"aim\" value=\""
            . $agoraUser['aim'] . "\" size=\"20\" maxlength=\"30\" />AOL IM</p>\n";
        $return .= "<p><input type=\"text\" name=\"yahoo\" value=\""
            . $agoraUser['yahoo'] . "\" size=\"20\" maxlength=\"30\" />Yahoo</p>\n";
        $return .= "<p><input type=\"text\" name=\"xfire\" value=\""
            . $agoraUser['xfire'] . "\" size=\"20\" maxlength=\"30\" />XFire</p>\n";
        $return .= "<p><input type=\"text\" name=\"skype\" value=\""
            . $agoraUser['skype'] . "\" size=\"20\" maxlength=\"30\" />Skype</p>\n";
        return $return;
    }

    /**
    * Saves the user edit tab postdata into the tab's permanent storage
    * @param object tab reflecting the tab database entry
    * @param object mosUser reflecting the user being displayed
    * @param int 1 for front-end, 2 for back-end
    * @param array _POST data for saving edited tab content as generated with getEditTab
    * @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
    */
    function saveEditTab($tab, $user, $ui, $postdata)
    {
        global $_CB_database;

        $jabber = cbAgoraFilter(JString::substr($postdata['jabber'],0,75));
        $icq = cbAgoraFilter(JString::substr($postdata['icq'],0,12));
        $msn = cbAgoraFilter(JString::substr($postdata['msn'],0,50));
        $aim = cbAgoraFilter(JString::substr($postdata['aim'],0,30));
        $yahoo = cbAgoraFilter(JString::substr($postdata['yahoo'],0,30));
        $xfire = cbAgoraFilter(JString::substr($postdata['xfire'],0,30));
        $skype = cbAgoraFilter(JString::substr($postdata['skype'],0,30));

        $return = null;

        $query = "UPDATE #__agora_users SET ";

        $query .= "`jabber`=$jabber, ";
        $query .= "`icq`=$icq, ";
        $query .= "`msn`=$msn, ";
        $query .= "`aim`=$aim, ";
        $query .= "`yahoo`=$yahoo, ";
        $query .= "`xfire`=$xfire, ";
        $query .= "`skype`=$skype ";
        $query .= "WHERE `jos_id`='" . $user->id . "'";

        $_CB_database->setQuery( $query );
        if(!$_CB_database->query())
            JError::raiseWarning(0,$_CB_database->getErrorMsg());
        /*
        $this->_setErrorMSG($_CB_database->getErrorMsg());
        return false;   //FIXME: something strange, it doesn't wish to work
                        //therefore we use JError::raiseWarning function*/

        return true;
    }

}

class getAgoraDisplayTab extends cbTabHandler {
/**
     * Construnctor
     */
    function getAgoraDisplayTab()
    {
        $this->cbTabHandler();
    }

    /**
    * Generates the HTML to display the user profile personality tab
    * @param object tab reflecting the tab database entry
    * @param object mosUser reflecting the user being displayed
    * @param int 1 for front-end, 2 for back-end
    * @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
    */
    function getDisplayTab($tab,$user,$ui)
    {
        $return = null;
        $lang = JFactory::getLanguage();
        $lang->load('plg_cbagora_plus');
        $agoraUser = cbAgoraGetUser($user->id);

        $return .= "<p>" . JText::_('CB_AGORA_SHOW_SMILES') . ":\t" . ($agoraUser['show_smilies']==1?"Yes":"No") . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_SHOW_SIGS') . ":\t" . ($agoraUser['show_sig']==1?"Yes":"No") . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_SHOW_AVATARS') . ":\t" . ($agoraUser['show_avatars']==1?"Yes":"No") . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_SHOW_IMAGES') . ":\t" . ($agoraUser['show_img']==1?"Yes":"No") . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_SHOW_IMAGES_SIGS') . ":\t" . ($agoraUser['show_img_sig']==1?"Yes":"No") . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_REVERSE') . ":\t" . ($agoraUser['reverse_posts']==1?"Yes":"No") . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_TOPICS_PER_PAGE') . ":\t" . $agoraUser['disp_topics'] . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_POSTS_PER_PAGE') . ":\t" . $agoraUser['disp_posts'] . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_MANAGE_REPUTATION') . ":\t" . ($agoraUser['reputation_enable']==1?"Yes":"No") . "</p>\n";

        return $return;
    }
/**
    * Generates the HTML to display the user edit tab
    * @param object tab reflecting the tab database entry
    * @param object mosUser reflecting the user being displayed
    * @param int 1 for front-end, 2 for back-end
    * @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
    */
    function getEditTab($tab, $user, $ui)
    {
        $return = null;
        $lang = JFactory::getLanguage();
        $lang->load('plg_cbagora_plus');
        $agoraUser = cbAgoraGetUser($user->id);

        $return .= "<p><input type=\"checkbox\" name=\"show_smilies\" "
            . ($agoraUser['show_smilies']==1?"checked":"") . " />" . JText::_('CB_AGORA_SHOW_SMILES') . "</p>\n";

        $return .= "<p><input type=\"checkbox\" name=\"show_sig\" "
            . ($agoraUser['show_sig']==1?"checked":"") . " />" . JText::_('CB_AGORA_SHOW_SIGS') . "</p>\n";

        $return .= "<p><input type=\"checkbox\" name=\"show_avatars\" "
            . ($agoraUser['show_avatars']==1?"checked":"") . " />" . JText::_('CB_AGORA_SHOW_AVATARS') . "</p>\n";

        $return .= "<p><input type=\"checkbox\" name=\"show_img\" "
            . ($agoraUser['show_img']==1?"checked":"") . " />" . JText::_('CB_AGORA_SHOW_IMAGES') . "</p>\n";

        $return .= "<p><input type=\"checkbox\" name=\"show_img_sig\" "
            . ($agoraUser['show_img_sig']==1?"checked":"") . " />" . JText::_('CB_AGORA_SHOW_IMAGES_SIGS') . "</p>\n";

        $return .= "<p><input type=\"checkbox\" name=\"reverse_posts\" "
            . ($agoraUser['reverse_posts']==1?"checked":"") . " />" . JText::_('CB_AGORA_REVERSE') . "</p>\n";

        $return .= "<p><input type=\"text\" name=\"disp_topics\" value=\""
            . $agoraUser['disp_topics'] . "\" size=\"6\" maxlength=\"3\" />" . JText::_('CB_AGORA_TOPICS_PER_PAGE') . "</p>\n";
        $return .= "<p><input type=\"text\" name=\"disp_posts\" value=\""
            . $agoraUser['disp_posts'] . "\" size=\"6\" maxlength=\"3\" />" . JText::_('CB_AGORA_POSTS_PER_PAGE') . "</p>\n";

        $return .= "<p>" . JText::_('CB_AGORA_MANAGE_REPUTATION') . "</p>";
        $return .= "<p><input type=\"radio\" name=\"reputation\" value=\"1\" "
            . ($agoraUser['reputation_enable']==1?"checked":"") . " />Yes\n";
        $return .= "<input type=\"radio\" name=\"reputation\" value=\"0\" "
            . ($agoraUser['reputation_enable']==0?"checked":"") . " />No</p>\n";

        return $return;
    }

    /**
    * Saves the user edit tab postdata into the tab's permanent storage
    * @param object tab reflecting the tab database entry
    * @param object mosUser reflecting the user being displayed
    * @param int 1 for front-end, 2 for back-end
    * @param array _POST data for saving edited tab content as generated with getEditTab
    * @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
    */
    function saveEditTab($tab, $user, $ui, $postdata)
    {
        global $_CB_database;

        $return = null;

        $query = "UPDATE #__agora_users SET ";

        $showSmiles = empty($postdata['show_smilies']) ? 0 : 1;
        $showSig = empty($postdata['show_sig']) ? 0 : 1;
        $showAvatars = empty($postdata['show_avatars']) ? 0 : 1;
        $showImg = empty($postdata['show_img']) ? 0 : 1;
        $showImgSig = empty($postdata['show_img_sig']) ? 0 : 1;
        $reversePosts = empty($postdata['reverse_posts']) ? 0 : 1;
        $dispTopics = (int)abs($postdata['disp_topics']);
        $dispPosts = (int)abs($postdata['disp_posts']);
        $reputation = $postdata['reputation']? 1 : 0;

        $query .= "`show_smilies`='$showSmiles', ";
        $query .= "`show_sig`='$showSig', ";
        $query .= "`show_avatars`='$showAvatars', ";
        $query .= "`show_img`='$showImg', ";
        $query .= "`show_img_sig`='$showImgSig', ";
        $query .= "`reverse_posts`='$reversePosts', ";
        $query .= "`disp_topics`='$dispTopics', ";
        $query .= "`disp_posts`='$dispPosts', ";
        $query .= "`reputation_enable`='$reputation' ";
        $query .= "WHERE `jos_id`='" . $user->id . "'";

        $_CB_database->setQuery( $query );
        if(!$_CB_database->query())
            JError::raiseWarning(0,$_CB_database->getErrorMsg());
        /*
        $this->_setErrorMSG($_CB_database->getErrorMsg());
        return false;   //FIXME: something strange, it does not wish to work
                        //therefore we use JError::raiseWarning function*/

        return true;
    }
}

class getAgoraPersonalTab extends cbTabHandler {
/**
     * Construnctor
     */
    function getPersonalDisplayTab()
    {
        $this->cbTabHandler();
    }

    /**
    * Generates the HTML to display the user profile personal tab
    * @param object tab reflecting the tab database entry
    * @param object mosUser reflecting the user being displayed
    * @param int 1 for front-end, 2 for back-end
    * @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
    */
    function getDisplayTab($tab,$user,$ui)
    {
        $return = null;
        $lang = JFactory::getLanguage();
        $lang->load('plg_cbagora_plus');
        $agoraUser = cbAgoraGetUser($user->id);
        $dateFormat = cbAgoraDateFormat();
        switch($agoraUser['gender']) {
            case 1:
                $gender = JText::_('CB_AGORA_GENDER_MALE');
                break;
            case 2:
                $gender = JText::_('CB_AGORA_GENDER_FEMALE');
                break;
            default:
                $gender = JText::_('CB_AGORA_GENDER_HIDDEN');
        }


        $return .= "<p>" . JText::_('CB_AGORA_TITLE') . ":\t" . $agoraUser['title'] . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_LOCATION') . ":\t" . $agoraUser['location'] . "</p>\n";
        //TODO: add google maps to this place
        $return .= "<p>" . JText::_('CB_AGORA_WEBSITE') . ":\t<a href=\"" . $agoraUser['url'] .  "\">" . $agoraUser['url'] . "</a></p>";
        $return .= "<p>" . JText::_('CB_AGORA_GENDER') . ":\t" . $gender ."</p>";

        if ($agoraUser['hide_age']==1)
            $dateFormat = trim(eregi_replace('[ \./-]?y+[ \./-]?', '', $dateFormat));
        $return .= "<p>" . JText::_('CB_AGORA_BIRTHDAY') . ":\t". cbAgoraMonthFormat(date($dateFormat, $agoraUser['birthday']), $dateFormat) ."</p>";
        $return .= "<p>" . JText::_('CB_AGORA_BIRTHDAY_HIDE') . ":\t" . ($agoraUser['hide_age']==1?"Yes":"No") ."</p>";
        $return .= "<p>" . JText::_('CB_AGORA_INTERESTS') . ":\t" . $agoraUser['interests'] . "</p>";
        $return .= "<p>" . JText::_('CB_AGORA_SIGNATURE') . ":\t" . stripslashes(nl2br($agoraUser['signature'])) . "</p>\n";

        return $return;
    }
    /**
    * Generates the HTML to display the user edit tab
    * @param object tab reflecting the tab database entry
    * @param object mosUser reflecting the user being displayed
    * @param int 1 for front-end, 2 for back-end
    * @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
    */
    function getEditTab($tab, $user, $ui)
    {
        global $_CB_framework;
        $return = null;
        $lang = JFactory::getLanguage();
        $lang->load('plg_cbagora_plus');
        $agoraUser = cbAgoraGetUser($user->id);
        $day = (int)date("j",$agoraUser['birthday']);
        $month = (int)date("n",$agoraUser['birthday']);
        $year = (int)date("Y",$agoraUser['birthday']);
        $gmaps = cbAgoraGMaps();
        $lng = empty($agoraUser['longitude']) ? $gmaps['def_lng'] : $agoraUser['longitude'];
        $lat = empty($agoraUser['latitude']) ? $gmaps['def_lat'] : $agoraUser['latitude'];
		$opt_usermap = cbAgoraGetConf('o_usermap');
		$opt_usermap_key = cbAgoraGetConf('o_um_key');

        $return .= "<p><input type=\"text\" name=\"a_title\" value=\""
            . $agoraUser['title'] . "\" size=\"30\" maxlength=\"30\" />" . JText::_('CB_AGORA_TITLE') . "</p>\n";
		
		if ($opt_usermap && $opt_usermap_key) {
			$return .= "<p><input type=\"text\" name=\"a_location\" value=\""
				. $agoraUser['location'] . "\" size=\"30\" maxlength=\"30\" />" . JText::_('CB_AGORA_LOCATION') . "</p>\n";

			$return .= "<script type=\"text/javascript\" src=\"http://maps.google.com/maps?file=api&amp;v=1&amp;key=".$gmaps['key']."\"></script>\n";
			$return .= "<script type=\"text/javascript\" src=\""
			  . $_CB_framework->getCfg('live_site') . "/components/com_comprofiler/plugin/user/plug_agoraplus/agora.js\"></script>\n";
			$return .= "<div id=\"map\" style=\"width: 500px; height: 400px; position:aboslute;\"></div>\n";
			$return .= "<script type=\"text/javascript\">\n
						//<![CDATA[
						window.onload=";
			$return .= "gMapProfile($lng, $lat, " . $gmaps['def_zoom'].",1);\n
						//]]>
						</script>
						";

			$return .= "<p><input type=\"text\" id=\"lat\" name=\"a_latitude\" value=\"".
				JString::trim($lat) ."\" size=\"50\" />" . JText::_('CB_AGORA_LATITUDE') . "</p>\n";
			$return .= "<p><input type=\"text\" id=\"lng\" name=\"a_longitude\" value=\"".
				JString::trim($lng) ."\" size=\"50\" />" . JText::_('CB_AGORA_LONGITUDE') . "</p>\n";
		
		}
		
        $return .= "<p><input type=\"text\" name=\"a_url\" value=\""
            . $agoraUser['url'] . "\" size=\"50\" maxlength=\"80\" />" . JText::_('CB_AGORA_WEBSITE') . "</p>\n";

        $return .= "<p>Gender</p>\n";
        $return .= "<p><input type=\"radio\" name=\"a_gender\" value=\"1\" "
            . ($agoraUser['gender']==1?"checked":"") . " />" . JText::_('CB_AGORA_GENDER_MALE') . "\n";
        $return .= "<input type=\"radio\" name=\"a_gender\" value=\"2\" "
            . ($agoraUser['gender']==2?"checked":"") . " />" . JText::_('CB_AGORA_GENDER_FEMALE') . "</p>\n";
        $return .= "<p><input type=\"checkbox\" name=\"a_gender\" value=\"0\" "
            . ($agoraUser['gender']==0?"checked":"") . " />" . JText::_('CB_AGORA_GENDER_HIDDEN') . "</p>\n";

        //birthday part

        $return .= "<script type=\"text/javascript\" src=\"" . $_CB_framework->getCfg('live_site') . "/components/com_comprofiler/plugin/user/plug_agoraplus/agora.js\"></script>";
        $return .= "<p>Birthday</p>\n";
        $return .= "<select id=\"birthday-day\" name=\"birthday-day\" style=\"width:50px; \" >\n";
        for( $i=1; $i<32; $i++)
            $return .= "<option value=\"" . $i . "\" " . ($day==$i ? "selected" : "") . ">" . $i . "</option>\n";
        $return .= "</select>\n";

        $return .= "<select id=\"birthday-month\" name=\"birthday-month\" onChange=\"rewrite_days();\" style=\"width:100px; \" >\n";
        $return .= "<option value=\"1\"" . ($month==1 ? "selected" : "") . ">" . JText::_('CB_JANUARY') . "</option>";
        $return .= "<option value=\"2\"" . ($month==2 ? "selected" : "") . ">" . JText::_('CB_FEBRUARY') . "</option>";
        $return .= "<option value=\"3\"" . ($month==3 ? "selected" : "") . ">" . JText::_('CB_MARCH') . "</option>";
        $return .= "<option value=\"4\"" . ($month==4 ? "selected" : "") . ">" . JText::_('CB_APRIL') . "</option>";
        $return .= "<option value=\"5\"" . ($month==5 ? "selected" : "") . ">" . JText::_('CB_MAY') . "</option>";
        $return .= "<option value=\"6\"" . ($month==6 ? "selected" : "") . ">" . JText::_('CB_JUNE') . "</option>";
        $return .= "<option value=\"7\"" . ($month==7 ? "selected" : "") . ">" . JText::_('CB_JULY') . "</option>";
        $return .= "<option value=\"8\"" . ($month==8 ? "selected" : "") . ">" . JText::_('CB_AUGUST') . "</option>";
        $return .= "<option value=\"9\"" . ($month==9 ? "selected" : "") . ">" . JText::_('CB_SEPTEMBER') . "</option>";
        $return .= "<option value=\"10\"" . ($month==10 ? "selected" : "") . ">" . JText::_('CB_OCTOBER') . "</option>";
        $return .= "<option value=\"11\"" . ($month==11 ? "selected" : "") . ">" . JText::_('CB_NOVEMBER') . "</option>";
        $return .= "<option value=\"12\"" . ($month==12 ? "selected" : "") . ">" . JText::_('CB_DECEMBER') . "</option>";
        $return .= "</select>\n";

        $return .= "<select id=\"birthday-year\" name=\"birthday-year\" onChange=\"rewrite_days();\" style=\"width:80px; \" >\n";
        for( $i=1922; $i<2002; $i++)
            $return .= "<option value=\"" . $i . "\" " . ((int)$year==$i ? "selected" : "") . ">" . $i . "</option>\n";
        $return .= "</select>\n";

        $return .= "<p><input type=\"checkbox\" name=\"a_hide_age\" "
            . ($agoraUser['hide_age']==1?"checked":"") . " />" . JText::_('CB_AGORA_BIRTHDAY_HIDE') . "</p>\n";

        $return .= "<p><input type=\"text\" name=\"a_interests\" value=\""
            . $agoraUser['interests'] . "\" size=\"70\" maxlength=\"254\" />" . JText::_('CB_AGORA_INTERESTS') . "</p>\n";

        $return .= "<p>" . JText::_('CB_AGORA_SIGNATURE_INFO') . "</p>\n";
        $return .= "<p>" . JText::_('CB_AGORA_SIGNATURE_MAXLENGTH') . ": 400 / " . JText::_('CB_AGORA_SIGNATURE_MAXLINES') . ": 4</p>\n";
        $return .= "<textarea name=\"a_sig\" rows=\"4\" cols=\"65\">" . $agoraUser['signature'] . "</textarea>";

        return $return;
    }

    /**
    * Saves the user edit tab postdata into the tab's permanent storage
    * @param object tab reflecting the tab database entry
    * @param object mosUser reflecting the user being displayed
    * @param int 1 for front-end, 2 for back-end
    * @param array _POST data for saving edited tab content as generated with getEditTab
    * @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
    */
    function saveEditTab($tab, $user, $ui, $postdata)
    {
        global $_CB_database;

        $return = null;

        $title = cbAgoraFilter(JString::substr($postdata['a_title'],0,30));
        $location = cbAgoraFilter(JString::substr($postdata['a_location'],0,30));
        $latitude = cbAgoraFilter(JString::substr($postdata['a_latitude'],0,50));
        $longitude = cbAgoraFilter(JString::substr($postdata['a_longitude'],0,50));
        $url = cbAgoraFilter(JString::substr($postdata['a_url'],0,80));
        $gender = cbAgoraFilter($postdata['a_gender']);
        $day = $postdata['birthday-day'];
        $month = $postdata['birthday-month'];
        $year = $postdata['birthday-year'];
        $birthday = mktime(0,0,0,$month,$day,$year);

        $sig = cbAgoraFilter(JString::substr($postdata['a_sig'],0,400));

        $hideAge = empty($postdata['a_hide_age']) ? 0 : 1;
        $interests = cbAgoraFilter(JString::substr($postdata['a_interests'],0,254));

        $query = "UPDATE #__agora_users SET ";

        $query .= "`title`=$title, ";
        $query .= "`location`=$location, ";
        $query .= "`latitude`=$latitude, ";
        $query .= "`longitude`=$longitude, ";
        $query .= "`url`=$url, ";
        $query .= "`gender`=$gender, ";
        $query .= "`birthday`='$birthday', ";
        $query .= "`hide_age`=$hideAge, ";
        $query .= "`signature`=$sig, ";
        $query .= "`interests`=$interests ";

        $query .= "WHERE `jos_id`='" . $user->id . "'";
        $_CB_database->setQuery( $query );
        if(!$_CB_database->query())
            JError::raiseWarning(0,$_CB_database->getErrorMsg());
        /*
        $this->_setErrorMSG($_CB_database->getErrorMsg());
        return false;   //FIXME: something strange, it does not wish to work
                        //therefore we use JError::raiseWarning function*/

        return true;
    }
}

class getAgoraPostsTab extends cbTabHandler {
/**
     * Construnctor
     */
    function getAgoraDisplayTab()
    {
        $this->cbTabHandler();
    }
	
    /**
    * Generates the HTML to display the user profile personality tab
    * @param object tab reflecting the tab database entry
    * @param object mosUser reflecting the user being displayed
    * @param int 1 for front-end, 2 for back-end
    * @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
    */
    function getDisplayTab($tab,$user,$ui)
    {
        $return = null;
		
		$params = $this->params;
		$limit = $params->get('numPosts', '10');
		
        $lang = JFactory::getLanguage();
        $lang->load('plg_cbagora_plus');
        $agoraUser = cbAgoraGetUser($user->id);
		
		$posts = cbAgoraGetPosts($user->id, $limit);
		
		$per_page = intval($agoraUser['disp_posts']) > 0 ? $agoraUser['disp_posts'] : intval(cbAgoraGetConf('o_disp_posts_default'));
		
		$return = '<table id="cbtf_2" class="cbFieldsContentsTab cbFields">
					<tr class="sectiontableentry2">
						<td class="titleCell">'.JText::_('CB_AGORA_TOPIC').'</td>
						<td class="titleCell">'.JText::_('CB_AGORA_STATS').'</td>
						<td class="titleCell">'.JText::_('CB_AGORA_LASTPOST').'</td>
					</tr>
		';
		
		foreach ($posts as $k => $post) {
			$type = ($k%2 > 0)? 2 : 1 ;
			$num_pages = ceil( intval($post['num_replies']+1) / $per_page);
			$last_url = $agoraUser['reverse_posts'] ? JRoute::_('index.php?option=com_agora&task=topic&id='.$post['id'].'#p'.$post['last_post_id']) :  JRoute::_('index.php?option=com_agora&task=topic&id='.$post['id'].'&p='.$num_pages.'#p'.$post['last_post_id']) ;
			$forum_url = JRoute::_('index.php?option=com_agora&task=forum&id='.$post['forum_id']);
			
			$return .= 
				'<tr class="sectiontableentry'.$type.'">
					<td class="fieldCell">
						'.$post['subject'].'
						<br/>
						'.JText::_('CB_AGORA_AUTHOR').':' . $post['poster'] . '
						<br/>
						'.JText::_('CB_AGORA_FORUM').':<a href="'.$forum_url.'" title="' . $post['forum_name'] . '">' . $post['forum_name'] . '</a>
					</td>
					<td class="fieldCell">
						'.$post['num_replies'].' '.JText::_('CB_AGORA_REPLIES').'<br/>
						'.$post['num_views'].' '.JText::_('CB_AGORA_VIEWS').'
					</td>
					<td class="fieldCell">
						<a href="'.$last_url.'" title="'.$post['subject'].'">'.date('j.m.Y H:i:s',$post['last_post']).'</a>
						<br/>
						'.JText::_('CB_AGORA_BY').' '.$post['last_poster'].'
					</td>
				</tr>';
		}
		
		$return .= '</table>';
		
        return $return;
    }
	
    function getEditTab($tab, $user, $ui) {}

    function saveEditTab($tab, $user, $ui, $postdata) {}
}

class getAgoraSubscriptionsTab extends cbTabHandler {
/**
     * Construnctor
     */
    function getAgoraDisplayTab()
    {
        $this->cbTabHandler();
    }
	
    /**
    * Generates the HTML to display the user profile personality tab
    * @param object tab reflecting the tab database entry
    * @param object mosUser reflecting the user being displayed
    * @param int 1 for front-end, 2 for back-end
    * @returns mixed : either string HTML for tab content, or false if ErrorMSG generated
    */
    function getDisplayTab($tab,$user,$ui)
    {
        $return = null;
		
		$params = $this->params;
		$limit = $params->get('numSubs', '10');
		
        $lang = JFactory::getLanguage();
        $lang->load('plg_cbagora_plus');
        $agoraUser = cbAgoraGetUser($user->id);
		
		$sub_topics = cbAgoraGetSubscribedTopics($user->id, $limit);
		
		$return = '<table id="cbtf_2" class="cbFieldsContentsTab cbFields">
					<tr class="sectiontableentry1">
						<td colspan="4" class="titleCell">'.JText::_('CB_AGORA_TOPICS').'</td>
					</tr>
					<tr class="sectiontableentry2">
						<td class="titleCell">'.JText::_('CB_AGORA_TOPIC').'</td>
						<td class="titleCell">'.JText::_('CB_AGORA_AUTHOR').'</td>
						<td class="titleCell">'.JText::_('CB_AGORA_REPLIES2').'</td>
						<td class="titleCell">'.JText::_('CB_AGORA_ACTION').'</td>
					</tr>
		';
		
		foreach ($sub_topics as $k => $topic) {
			$type = ($k%2 > 0)? 2 : 1 ;
			$topic_url = JRoute::_('index.php?option=com_agora&task=topic&id='.$topic['id']);
			$unsubscribe_url = JRoute::_('index.php?option=com_agora&task=topic&action=unsubscribe&id='.$topic['id']);
			
			$return .= 
				'<tr class="sectiontableentry'.$type.'">
					<td class="fieldCell">
						<a href="'.$topic_url.'">'.$topic['subject'].'</a>
					</td>
					<td class="fieldCell">
						' . $topic['poster'] . '
					</td>
					<td class="fieldCell">
						'.$topic['num_replies'].'
					</td>
					<td class="fieldCell">
						<a href="'.$unsubscribe_url.'" title="'.JText::_('CB_AGORA_UNSUBSCRIBE').'">'.JText::_('CB_AGORA_UNSUBSCRIBE').'</a>
					</td>
				</tr>';
		}
		
		$return .= '</table>';

		$sub_forums = cbAgoraGetSubscribedForums($user->id, $limit);
		
		$return .= '<table id="cbtf_2" class="cbFieldsContentsTab cbFields">
					<tr class="sectiontableentry1">
						<td colspan="4" class="titleCell">'.JText::_('CB_AGORA_FORUMS').'</td>
					</tr>
					<tr class="sectiontableentry2">
						<td class="titleCell">'.JText::_('CB_AGORA_FORUM').'</td>
						<td class="titleCell">'.JText::_('CB_AGORA_TOPICS2').'/'.JText::_('CB_AGORA_POSTS').'</td>
						<td class="titleCell">'.JText::_('CB_AGORA_ACTION').'</td>
					</tr>
		';
		
		foreach ($sub_forums as $k => $forum) {
			$type = ($k%2 > 0)? 2 : 1 ;
			$forum_url = JRoute::_('index.php?option=com_agora&task=forum&id='.$forum['id']);
			$unsubscribe_url = JRoute::_('index.php?option=com_agora&task=forum&action=unsubscribe_forum&id='.$forum['id']);
			
			$return .= 
				'<tr class="sectiontableentry'.$type.'">
					<td class="fieldCell">
						<a href="'.$forum_url.'">'.$forum['forum_name'].'</a>
						<br/>
						<i>'.$forum['forum_desc'].'</i>
					</td>
					<td class="fieldCell">
						' . $forum['num_topics'] . ' '.JText::_('CB_AGORA_TOPICS2').'<br/>
						' . $forum['num_posts'] . ' '.JText::_('CB_AGORA_POSTS').'
					</td>
					<td class="fieldCell">
						<a href="'.$unsubscribe_url.'" title="'.JText::_('CB_AGORA_UNSUBSCRIBE').'">'.JText::_('CB_AGORA_UNSUBSCRIBE').'</a>
					</td>
				</tr>';
		}
		
		$return .= '</table>';
		
        return $return;
    }
	
    function getEditTab($tab, $user, $ui) {}

    function saveEditTab($tab, $user, $ui, $postdata) {}
}

?>
