<?php

defined ( '_JEXEC' ) or die ( 'Direct Access to this location is not allowed.' );

require_once (JPATH_SITE .DS.'plugins'.DS.'content'.DS.'agoradiscuss'.DS.'helpers'.DS.'agora'.DS.'db.php');

class AODAccess

{

		var $db;

		var $roles;
	
		var $access;

		static function & getInstance()

		{

			static $inst;

			if (!isset($inst)) {

				$inst = new AODAccess();

			}

			return $inst;

		}

		

		function __construct()

		{

			$this->db = & AgoraDatabase::getInstance('agora_');

			$this->prefix = $this->db->getPrefix().'agora_';

			$this->db->setQuery('SELECT id, name FROM ##__roles');

			$roles = $this->db->loadRowList();
			 
			foreach ($roles as $role) {

				$role_name = strtoupper('AGORA_ROLE_'.$role[1]);

				define($role_name,intval($role[0]));

				$this->roles[$role[0]] = $role_name;

			}

			$this->access = array('read','bbcode','bbcode_img','read_rss','post_reply','post_poll','post_topic','edit_topic','edit_posts','delete_topics','delete_posts', 'make_sticky', 'close_topic', 'use_captcha');


		}

		function getForumAccess($forum_id, $user_id)
		{

			$this->db->bind('forum_id',$forum_id,'integer');
			if ($user_id != 0) {
				// real user
				$this->db->bind('user_id',$user_id,'integer');

				$this->db->setQuery('SELECT user_group.role_id, permissions.*'.
								' FROM ##__user_group AS user_group'.
								' INNER JOIN ##__group_forum AS group_forum'.
								'  ON user_group.group_id = group_forum.group_id'.
								'  AND user_group.role_id = group_forum.role_id'.
								' INNER JOIN ##__permissions AS permissions'.
								'  ON permissions.id = group_forum.access_id'.
								' WHERE user_group.user_id = :user_id'.
								' AND group_forum.forum_id = :forum_id');
				$access = $this->db->loadAssocList();
			} else {
				$role_id = '1';
				$this->db->bind('role_id',$role_id,'integer');
				$this->db->setQuery('SELECT group_forum.role_id,permissions.*'.
								' FROM ##__group_forum AS group_forum'.
								' INNER JOIN ##__permissions AS permissions'.
								'  ON permissions.id = group_forum.access_id'.
								' WHERE group_forum.role_id = :role_id'.
								' AND group_forum.forum_id = :forum_id');
				$access = $this->db->loadAssocList();
			}

			$total_access = array();
			foreach ($access as $access_row) {
				if (($access_row['role_id'] == AGORA_ROLE_MODERATOR || $access_row['role_id'] == AGORA_ROLE_ADMIN) && $access_row['post_reply'] != 0) {
					$access_row['can_moderate'] = 1;
				} else {
					$access_row['can_moderate'] = 0;
				}
				//unset($access_row['role_id']);
				unset($access_row['id']);

				foreach ($access_row as $perm=>$value) {
					
					if (!isset($total_access[$perm])) {
						$total_access[$perm] = intval($value);
						continue;
					}
					$total_access[$perm] = $total_access[$perm] || intval($value);
				}
			}
			return $total_access;
		}


}
?>
