<?php
defined ( '_JEXEC' ) or die ( 'Direct Access to this location is not allowed.' );
require_once (JPATH_SITE.DS .'plugins'.DS.'content'.DS.'agoradiscuss'.DS.'helpers'.DS.'agora'.DS.'db.php');
class AUserHelper
{
    public $agora_config = array();
    public $_user = array();
    public $db;
    static function & getInstance()
    {
        static $inst;
        if (!isset($inst)) {
            $inst = new AUserHelper();
        }
        return $inst;
    }
    function __construct()
    {
        $this->db = & AgoraDatabase::getInstance('agora_');
        $this->agora_config = $this->getAgoraConfig();
        $this->_user = $this->loadGuest();

    }
    function getAgoraConfig(){
        $sql = "SELECT conf_name, conf_value FROM ##__config";
        $this->db->setQuery($sql);
        $list = $this->db->loadRowList();
        if (!$list) return false;
        $data = array();
        foreach ($list as $result) {
            $fname = $result[0];
            $fvalue = $result[1];
            $data[$fname] = $fvalue;
        }
        $this->agora_config = $data;
        return $this->agora_config;
    }
    function loadGuest()
    {

        $user = array();
        $user['id'] = 0;
        $user['username'] = 'Guest';
        $user['disp_posts'] = $this->agora_config['o_disp_posts_default'];
        $user['disp_topics'] = $this->agora_config['o_disp_topics_default'];
        $user['reverse_posts'] = 0;
        $user['show_smilies'] = 1;
        $user['show_sig'] = 0;
        $user['show_img_sig'] = 0;
        $user['show_img'] = 1;
        $user['is_superadmin'] = 0;
        $user['auto_subscriptions'] = 0;
        $this->_user = $user;
        return $user;
    }
    function getUserId($username)
    {
        //// We need it in PM // if we need real name from Joomla we will return to JOIN in future
/*			$this->db->setQuery("SELECT id".
                " FROM {$this->table} AS u".
                " INNER JOIN #__users AS j".
                "  ON u.jos_id = j.id".
                " WHERE LOWER(TRIM(j.name)) = LOWER({$this->db->Quote(trim($username))})");*/
        $this->db->bind('username',trim($username),'string');
        $this->db->setQuery('SELECT id FROM ##__users WHERE LOWER(TRIM(username)) = LOWER(:username)');
        return $this->db->loadResult();
    }
    function getJoomlaUserId($username)
    {
        //// We need it in PM // if we need real name from Joomla we will return to JOIN in future
/*			$this->db->setQuery("SELECT id".
                " FROM {$this->table} AS u".
                " INNER JOIN #__users AS j".
                "  ON u.jos_id = j.id".
                " WHERE LOWER(TRIM(j.name)) = LOWER({$this->db->Quote(trim($username))})");*/
        $this->db->bind('username',trim($username),'string');
        $this->db->setQuery('SELECT jos_id FROM ##__users WHERE LOWER(TRIM(username)) = LOWER(:username)');
        return $this->db->loadResult();
    }
    function getUserTitle($username)
    {
        //// We need it in PM // if we need real name from Joomla we will return to JOIN in future
/*			$this->db->setQuery("SELECT id".
                " FROM {$this->table} AS u".
                " INNER JOIN #__users AS j".
                "  ON u.jos_id = j.id".
                " WHERE LOWER(TRIM(j.name)) = LOWER({$this->db->Quote(trim($username))})");*/
        $this->db->bind('username',trim($username),'string');
        $this->db->setQuery('SELECT title FROM ##__users WHERE LOWER(TRIM(username)) = LOWER(:username)');
        return $this->db->loadResult();
    }
    function getUserSignature($username)
    {
        //// We need it in PM // if we need real name from Joomla we will return to JOIN in future
/*			$this->db->setQuery("SELECT id".
                " FROM {$this->table} AS u".
                " INNER JOIN #__users AS j".
                "  ON u.jos_id = j.id".
                " WHERE LOWER(TRIM(j.name)) = LOWER({$this->db->Quote(trim($username))})");*/
        $this->db->bind('username',trim($username),'string');
        $this->db->setQuery('SELECT signature FROM ##__users WHERE LOWER(TRIM(username)) = LOWER(:username)');
        return $this->db->loadResult();
    }

    function loadCurrent()
    {
        $my = & JFactory::getUser();
        if ($my->id) {
            $user = $this->load($my->id,'jos_id');
            if (!$user) {
                $user = $this->load($my->id,'jos_id');
            }
            if ($my->usertype == 'Super Administrator' || $my->usertype == 'Administrator') {
                $user['is_superadmin'] = 1;
            } else {
                $user['is_superadmin'] = 0;
            }
            $this->_user = $user;
            return $user;
        } else {
            $this->_user = $this->loadGuest();
            return $this->_user;
        }
    }

    function load($value, $field = 'id')
    {
        $q_id = $this->db->Quote($value);
        $sql = 'SELECT u.*, session.userid IS NOT NULL as online'.
            ' FROM ##__users AS u '.
            ' LEFT JOIN #__session AS session'.
                ' ON u.jos_id = session.userid'.
            " WHERE u.$field = $q_id";
        $this->db->setQuery($sql);
        $user = $this->db->loadAssoc();
        $this->_user = $user;
        return $user;
    }
    function prepareUserAvatar($user)  // prepares users Avatar for display
    {
        unset($avatar);
        if (intval($this->agora_config['o_community_builder'])) {


            $cb_avatar = $this->getCbAvatar($user['jos_id']);
            if ($cb_avatar) {

                $cb_avatar = JURI::root(). 'images/comprofiler/'. $cb_avatar;

            }
            else
            {
                $cb_avatar =JURI::base().'components/com_agora/img/pre_avatars/noavatar.jpg';
            }

            $user['avatar'] = $cb_avatar;

        }
        else if (intval($this->agora_config['o_jomsocial'])) {


            $Jomsocial_avatar = $this->getJomsocialAvatar($user['jos_id']);

            if ($Jomsocial_avatar) {

                $Jomsocial_avatarSz = JPATH_SITE . DS . $Jomsocial_avatar;

                if ($img_size = @getimagesize($Jomsocial_avatarSz))
                $user['avatar_size'] = $img_size[3];

                $Jomsocial_avatar = JURI::root(). $Jomsocial_avatar;

            }
            else
            {
                $Jomsocial_avatar =JURI::base().'components/com_agora/'.'img/pre_avatars/noavatar.jpg';
            }

            $user['avatar'] = $Jomsocial_avatar;

        }
        else if (intval($this->agora_config['o_joomunity'])) {


            $joomunity_avatar = $$this->getJoomunityAvatar($user['jos_id']);
            if ($joomunity_avatar) {
                //components/com_joomunity/files/avatars/
                $joomunity_avatarSz = JPATH_SITE . DS . 'components'. DS . 'com_joomunity'. DS. 'files'  . DS. 'avatars' . DS. $joomunity_avatar;

                if ($img_size = @getimagesize($joomunity_avatarSz))
                $user['avatar_size'] = $img_size[3];

                $joomunity_avatar = JURI::root(). 'components/com_joomunity/files/avatars/'. $joomunity_avatar;

            }
            else
            {
                $joomunity_avatar =JURI::base().'components/com_agora/'.'img/pre_avatars/noavatar.jpg';
            }

            $user['avatar'] = $joomunity_avatar;

        }
        else if (intval($this->agora_config['o_joomsocialsuite'])) {
            
            $joomsocialsuite = 'images/jsocialsuite/avatar/' .$user['jos_id']. '.gif';

            if ($joomsocialsuite) {

                $joomsocialsuite = JURI::root(). $joomsocialsuite;

            }
            else
            {
                $joomsocialsuite =JURI::base().'components/com_agora/'.'img/pre_avatars/noavatar.jpg';
            }

            $user['avatar'] = $joomsocialsuite;
        }
        else
        {

            $a_path = JPATH_SITE . DS . $this->agora_config['o_avatars_dir'] .DS. $user['id'];

            if ($img_size = @getimagesize($a_path.'.gif'))
            //$avatar = JURI::base().'components/com_agora/'.'img/pre_avatars/'.$user['id'].'.gif';
            $avatar = JURI::root(). $this->agora_config['o_avatars_dir'] .'/'.$user['id'].'.gif';
            else if ($img_size = @getimagesize($a_path.'.jpg'))
            //$avatar = JURI::base().'components/com_agora/'.'img/pre_avatars/'.$user['id'].'.jpg';
            $avatar = JURI::root(). $this->agora_config['o_avatars_dir'] .'/'.$user['id'].'.jpg';
            else if ($img_size = @getimagesize($a_path.'.png'))
            //$avatar = JURI::base().'components/com_agora/'.'img/pre_avatars/'.$user['id'].'.png';
            $avatar = JURI::root(). $this->agora_config['o_avatars_dir'] .'/'.$user['id'].'.png';

            if (isset($avatar)) {
                $user['avatar'] = $avatar;
                $user['avatar_size'] = $img_size[3];
            } else {
                $user['avatar'] = JURI::base().'components/com_agora/img/pre_avatars/noavatar.jpg';
                $user['avatar_size'] = '';
            }
        }
        $this->_user = $user;
        return $user;
    }

    function getCbAvatar($jos_id)
    {
        $this->db->setQuery('SELECT avatar FROM #__comprofiler WHERE user_id = '.intval($jos_id));
        return $this->db->loadResult();
    }
    function getJomsocialAvatar($jos_id)
    {
        $this->db->setQuery('SELECT avatar FROM #__community_users WHERE userid = '.intval($jos_id));
        return $this->db->loadResult();
    }

    function getJomsocialThumb($jos_id)
    {
        $this->db->setQuery('SELECT thumb FROM #__community_users WHERE userid = '.intval($jos_id));
        return $this->db->loadResult();
    }
    function getJoomunityAvatar($jos_id)
    {
        $this->db->setQuery('SELECT user_picture FROM #__joom_users WHERE user_id = '.intval($jos_id));
        return $this->db->loadResult();
    }
}	
?>
