<?php
/**
* @version		$Id: aodbutton.php $
* @package		jVitals
* @license		GNU/GPL, see LICENSE.php
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

/**
 * Editor Agora Olympus Discuss Buton
 *
 * @package Editors-xtd
 * @since 1.5
 */
class plgButtonAODButton extends JPlugin
{
	/**
	 * Constructor
	 *
	 * For php4 compatability we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @param object $subject The object to observe
	 * @param 	array  $config  An array that holds the plugin configuration
	 * @since 1.5
	 */
	function plgButtonAODButton(& $subject, $config)
	{
		parent::__construct($subject, $config);
	}

	/**
	 * @return array A two element array of ( imageName, textToInsert )
	 */
	function onDisplay($name)
	{
		global $mainframe;

		$doc 		=& JFactory::getDocument();
		$template 	= $mainframe->getTemplate();

		JPlugin::loadLanguage ( 'plg_editors_aodbutton', JPATH_ADMINISTRATOR );

		// button is not active in specific content components

		$getContent = $this->_subject->getContent($name);
		$present = JText::_('There is already an AOD tag in this article', true) ;
		$js = "
			function insertAOD(editor) {
				var content = $getContent
				if (content.match(/{discuss\s*.*?}/i)) {
					alert('$present');
					return false;
				} else {
					jInsertEditorText(\"{discuss forum:".JText::_('ENTER_FORUM_ID')."}\", editor);
				}
			}
			";

		$doc->addScriptDeclaration($js);

		$declaration	=".button2-left .aodbutton 	{ background: url(components/com_agoraolympusdiscussplugin/assets/images/aodbutton.png) 100% 0 no-repeat; } ";

		$doc->addStyleDeclaration($declaration);

		$button = new JObject();
		$button->set('modal', false);
		$button->set('onclick', 'insertAOD(\''.$name.'\');return false;');
		$button->set('text', JText::_('AOD_TEXT'));
		$button->set('name', 'aodbutton');
		// TODO: The button writer needs to take into account the javascript directive
		//$button->set('link', 'javascript:void(0)');
		$button->set('link', '#');

		return $button;
	}
}
