<?php
/**
* @version $Id: agorasearch.php Wed, March 11, 2009  12:13 jVitals 
* @package Agora SearchBot Plugin
* @copyright Copyright (C) jVitals Team 2009. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see components/com_agora/LICENSE.php
* Agora is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See components/com_agora/COPYRIGHT.php for copyright notices and details.
* visit www.jVitals.com
*/

defined( '_JEXEC' ) or die( 'Restricted access' );

$mainframe->registerEvent( 'onSearch', 'botSearchAgora' );
$mainframe->registerEvent( 'onSearchAreas', 'botSearchAgoraAreas' );

function &botSearchAgoraAreas() {
	static $areas = array( 'agorasearch' => 'Forums'	);
	return $areas;
}

function stripBBCode($mess_text) {
 	$pattern 	= '|[[\/\!]*?[^\[\]]*?]|si';
	 $replace 	= '';
	 
	 return preg_replace($pattern, $replace, $mess_text);
}

function botSearchAgora ( $text, $phrase='', $ordering='', $areas=null )
{
	if (!$text) {
		return array();
	}
	
	if (is_array( $areas )) {
		if (!array_intersect( $areas, array_keys( botSearchAgoraAreas() ) )) {
			return array();
		}
	}
	
		$plugin       =& JPluginHelper::getPlugin('search', 'agorasearch');
		$pluginParams = new JParameter( $plugin->params );
		
		$db           =& JFactory::getDBO();
		$user         =& JFactory::getUser();
	
		$limit        = $pluginParams->get( 'search_limit', 50 );
		$searchSub    = $pluginParams->get( 'search_sub', 1 ); 
		$searchFrm    = $pluginParams->get( 'search_frm', 1 );

	$query = "SELECT id FROM #__menu WHERE link='index.php?option=com_agora'";
	$db->setQuery($query);
	$agora_Itemid = $db->loadResult();
	
	if ($phrase == 'exact')
	{
		if ($searchSub) {
			$where = "(LOWER(a.message) LIKE '%$text%') OR (LOWER(b.subject) LIKE '%$text%') ";
		}
		else
		{
			$where = "(LOWER(a.message) LIKE '%$text%') ";
		}
		$whereForumD = "(LOWER(forum_name) LIKE '%$text%') OR (LOWER(forum_desc) LIKE '%$text%') ";
		
	}
	else
	{
		$words = explode( ' ', $text );
		$wheres = array();

		foreach ($words as $word) {
			
			if ($searchSub) {
				$wheres[] = "(LOWER(a.message) LIKE '%$word%') OR (LOWER(b.subject) LIKE '%$word%') ";
			}
			else
			{
				$wheres[] = "(LOWER(a.message) LIKE '%$word%') ";
			}
			$wheresF[] = "(LOWER(forum_name) LIKE '%$word%') OR (LOWER(forum_desc) LIKE '%$word%') ";
			}

		if($phrase == 'all') {
			$separator = "AND";
			}
		else {
			$separator = "OR"; 
			}

		$where = '(' . implode( ") $separator (" , $wheres ) . ')';
		$whereForumD = '(' . implode( ") $separator (" , $wheresF ) . ')';
	}

	switch ($ordering) {
		case 'oldest':
			$order = 'a.posted ASC';
			break;

		case 'popular':  // To Do!! DONE!
			$order = 'b.num_views DESC';
			break;

		case 'newest':
		default:
			$order = 'a.posted DESC';
			break;
		}  
	
	// get Agora user_id
	$query = "SELECT id FROM #__agora_users WHERE jos_id =" .$user->id ;
	
	$db->setQuery( $query);	
	$auser_id = $db->loadResult();
		
		if ($auser_id != 0) { 

			  $query =      "SELECT forum_id".
							" FROM #__agora_group_forum AS group_forum".
							" INNER JOIN #__agora_user_group AS user_group".
							" ON user_group.group_id = group_forum.group_id".
							" AND user_group.role_id = group_forum.role_id".
							" INNER JOIN #__agora_permissions AS permissions".
							" ON permissions.id = group_forum.access_id".
							" WHERE user_group.user_id = ". $auser_id .
							" AND permissions.read = 1";
			$db->setQuery( $query);
			$allowed_forums = $db->loadResultArray();
		} 
		else 
		{
			  $query =      "SELECT forum_id".
							" FROM #__agora_group_forum AS group_forum".
							" INNER JOIN #__agora_permissions AS permissions".
							" ON permissions.id = group_forum.access_id".
							" WHERE group_forum.role_id = 1".
							" AND group_forum.group_id = 1".
							" AND permissions.read = 1";
							
			$db->setQuery( $query);
			$allowed_forums = $db->loadResultArray();
		}
		
		$allowedforums = implode('\',\'', $allowed_forums);
		
		$query = "SELECT b.subject AS title, a.message AS text, a.posted AS created, " .
				" CONCAT('Agora Forum- ', c.forum_name) AS section, a.topic_id, " .
				" CONCAT('index.php?option=com_agora&task=topic&id=',a.topic_id,'&p=1&Itemid=". $agora_Itemid ."#p', a.id) AS href," .
				" '2' AS browsernav, b.num_views" .
				" FROM #__agora_posts AS a INNER JOIN #__agora_topics AS b ON b.id = a.topic_id".
				" INNER JOIN #__agora_forums AS c ON c.id = b.forum_id " .
				" WHERE $where AND c.enable = 1"; 
				
		if (($user->usertype != 'Super Administrator') && ($user->usertype != 'Administrator')) {
			$query .= " AND c.id IN ('" .$allowedforums. "') ";
		}
		
		$query .= " ORDER BY $order";
		$db->setQuery( $query, 0, $limit );
		$rtn = $db->loadObjectList();
	
 		$count	= count($rtn);

		if($count) {
 			foreach($rtn as $row) 
			{ 
				$row->text = stripBBCode($row->text);
			} // for each 
		 } // if count 
		 
		 // Search Forum Descriptions
	if ($searchFrm) {	 
		$query = "SELECT forum_name AS title, forum_desc AS text, '' AS created, " .
				" CONCAT('Agora - Relevant Forum') AS section, " .
				" CONCAT('index.php?option=com_agora&task=forum&id=',id,'&p=1&Itemid=". 
				  $agora_Itemid ."') AS href, '2' AS browsernav" .
				" FROM #__agora_forums WHERE ".$whereForumD." AND enable = 1" ; 
				
		if (($user->usertype != 'Super Administrator') && ($user->usertype != 'Administrator')) {
			$query .= "  AND id IN ('" .$allowedforums. "')";
		}
		
		$db->setQuery( $query, 0, $limit );
		
		$rtn2 = $db->loadObjectList();
		$rtn = array_merge($rtn, $rtn2);	
	}
	return $rtn;
}

?>